using System;
using System.Collections.Generic;
using System.Configuration;
using System.ServiceModel;
using System.Text;

namespace DerivativesCalculator
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Type serviceType = typeof(DerivativesCalculatorServiceType);

            string httpBaseAddress =
                ConfigurationManager.AppSettings["HTTPBaseAddress"];
            string tcpBaseAddress =
                ConfigurationManager.AppSettings["TCPBaseAddress"];
            Uri httpBaseAddressUri = new Uri(httpBaseAddress);
            Uri tcpBaseAddressUri = new Uri(tcpBaseAddress);
            Uri[] baseAdresses = new Uri[] { 
                httpBaseAddressUri,
                tcpBaseAddressUri};

            using(ServiceHost host = new ServiceHost(
                serviceType,
                baseAdresses))
            {
                host.Open();

                Console.WriteLine(
                    "The derivatives calculator service is available."
                );
                Console.ReadKey();

                host.Close();
            }
        }
    }
}
