using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace ConsumerBankingService
{
    [ServiceContract]
    public interface IConsumerBankingBillPayment
    {
        [OperationContract]
        bool PayBill(int accountNumber, int accountNumberToPay, decimal amount);

        [OperationContract]
        string GetRegisteredBills(int accountNumber);
    }



    class ConsumerBankingBillPayment : IConsumerBankingBillPayment
    {

        public bool PayBill(int accountNumber, int accountNumberToPay, decimal amount)
        {
            bool success = false;

            ConsumerBankingCore banking = new ConsumerBankingCore();
            success = banking.Withdraw(accountNumber,amount);
            
            ElectricBillPayProxy proxy = new ElectricBillPayProxy("BillPay");
            success = success && proxy.PayBill(accountNumberToPay, amount);
            Console.WriteLine("Paying {0} from Account {1} towards GenericElectric account {2}", amount, accountNumber,accountNumberToPay);
            
            return success; }

        public string GetRegisteredBills(int accountNumber)
        { return "result"; }
    
    
    }
}
