using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace ConsumerBankingService
{
    [ServiceContract(Session=true)]
    public interface IConsumerBankingCore
    {
        [OperationContract]
        bool Deposit(int accountNumber, decimal amount);
        [OperationContract]
        bool Withdraw(int accountNumber, decimal amount);
        [OperationContract]
        decimal GetBalance(int accountNumber);
    }
    // This will share the information per a single session
    //[ServiceBehavior(InstanceContextMode=InstanceContextMode.PerSession)]
   // [ServiceBehavior(InstanceContextMode = InstanceContextMode.Shareable)]
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
    class ConsumerBankingCore : IConsumerBankingCore
    {
        private decimal _balance = default(decimal);

        public bool Deposit(int accountNumber, decimal amount)
        {
            _balance = _balance + amount;
            Console.WriteLine("Depositing {0} into Account {1}", amount, accountNumber);
            Console.WriteLine("Balance:" + _balance.ToString());
            return true; }
        public bool Withdraw(int accountNumber, decimal amount)
        {
            _balance = _balance - amount;
            Console.WriteLine("Withdrawing {0} from Account {1}", amount, accountNumber);
            Console.WriteLine("Balance:" + _balance.ToString());
            return true; }
        public decimal GetBalance(int accountNumber)
        { return _balance; }
    
    }
}
