using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Transactions;

namespace ConsumerBankingService
{
    [ServiceContract]
    public interface IConsumerBankingBillPayment
    {
        [OperationContract]
        [TransactionFlow(TransactionFlowOption.Allowed)] //Added for Transaction Support
        bool PayBill(int accountNumber, int accountNumberToPay, decimal amount);

    }


    
    [ServiceBehavior]
    class ConsumerBankingBillPayment : IConsumerBankingBillPayment
    {

        public bool PayBill(int accountNumber, int accountNumberToPay, decimal amount)
        {
            bool success = false;

            using (TransactionScope tx = new TransactionScope(TransactionScopeOption.Required))
            {
                ConsumerBankingCoreProxy banking = new ConsumerBankingCoreProxy("CoreBanking");
                success = banking.Withdraw(accountNumber, amount);
                if (success)
                {
                    ElectricBillPayProxy proxy = new ElectricBillPayProxy("BillPay");
                    Console.WriteLine("Paying {0} from Account {1} towards GenericElectric account {2}", amount, accountNumber, accountNumberToPay);
                    success = proxy.PayBill(accountNumberToPay, amount);
                                   
                }
                return success;
            }
            
         
            
            return success; }

        public string GetRegisteredBills(int accountNumber)
        { return "result"; }
    
    
    }
}
