using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Configuration;

namespace ConsumerBankingService
{
    class Program
    {
        
        static void Main(string[] args)
        {

            // Get base address from app settings in configuration
            Uri baseAddressCore = new Uri(ConfigurationManager.AppSettings["baseAddressCore"]);
            Uri baseAddressBillPay = new Uri(ConfigurationManager.AppSettings["baseAddressBillPay"]);
            
            // Instantiate new ServiceHost 
            ServiceHost CoreServiceHost = new ServiceHost(typeof(ConsumerBankingCore), baseAddressCore);
            CoreServiceHost.Open();
            Console.WriteLine("Consumer Banking Service is Online.");
            Console.WriteLine("-----------------------------------");
            
            ServiceHost BillPayServiceHost = new ServiceHost(typeof(ConsumerBankingBillPayment), baseAddressBillPay);
            BillPayServiceHost.Open();
            Console.WriteLine("Consumer Bill Pay Service is Online.");
            Console.WriteLine("-----------------------------------");
            
            Console.WriteLine("Press any key to terminate service.");
            Console.ReadKey();

            CoreServiceHost.Close();
            BillPayServiceHost.Close();

        }
        
     }
}

