using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Transactions;

namespace GenericElectricCompany
{
    [ServiceContract]
    public interface IElectricBillPay
    {
        [OperationContract]
        [TransactionFlow(TransactionFlowOption.Required)] //Added for Transaction Support
        bool PayBill(int account, decimal amount);
        
        [OperationContract]
        decimal GetBalance(int account);
    
    }
    
    //Added for Sessions
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
    
    class ElectricBillPay : IElectricBillPay
    {
        public bool PayBill(int account, decimal amount)
        {
            
            Console.WriteLine("Paying {0} towards bill on Account {1}", amount, account);

            return true;
        }
        public decimal GetBalance(int account)
        {

            return 0;
        }


    }
}
