using System;
using System.Collections.Generic;
using System.Text;
using System.Messaging;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;
using System.Runtime.InteropServices;


[assembly: ApplicationName("StudentManagement")]
[assembly: ApplicationID("2C9BFEA5-005D-4218-8C69-A03F6B9037BA")]
[assembly: ApplicationActivation(ActivationOption.Server)]
[assembly: ApplicationAccessControl(false, AccessChecksLevel = AccessChecksLevelOption.Application)]

namespace WCFHandsOn
{
    [Guid("1C5677EC-8046-4c5b-B361-BA354CFA3DB3")]
    public interface IStudents
    {
        string Add(string FirstName, string LastName, string PhoneNumber);
        bool Update(string ID, string FirstName, string LastName, string PhoneNumber);
        bool Delete(string ID);
        System.Collections.ArrayList GetAll();
    
    }
    
    [Guid("E4A5D9FD-3B5F-4598-9E42-EC8D1329EE9D")]
    [ProgId("StudentManagement.Students")]
    public class Students : ServicedComponent, IStudents
    {
        public Students() { }
        
        string qPath = @"FormatName:DIRECT=OS:localhost\private$\school";
        public string Add(string FirstName, string LastName, string PhoneNumber)
        {
            //For any modifications to the data, we place the
            //request on a queue.

            //First we generate an System.Messaging.Message for the queue.
            try
            {
                string ID = Guid.NewGuid().ToString();
                /*Student student = new Student(ID, FirstName, LastName, PhoneNumber);

                System.Messaging.Message msg = GenerateAddMessage(student);

                //Now we place it to the queue
                PlaceMessageOnQueue(msg);
                */
                //This is a new student, return the GUID
                return ID;
            }
            catch (Exception e)
            {
                //Debug.WriteLine(e.ToString());
                throw e;
            }
        }
        public bool Update(string ID, string FirstName, string LastName, string PhoneNumber)
        {
            //For any modifications to the data, we place the
            //request on a queue.
            try
            {
                //First we generate an System.Messaging.Message for the queue.

                Student student = new Student(ID, FirstName, LastName, PhoneNumber);

                System.Messaging.Message msg = GenerateAddMessage(student);

                //Now we place it to the queue
                PlaceMessageOnQueue(msg);

                return true;
            }
            catch (Exception e)
            {
                return false;
            }

        }
        public bool Delete(string ID)
        {

            //For any modifications to the data, we place the
            //request on a queue.

            //First we generate an System.Messaging.Message for the queue.
            try
            {
                //First we generate an System.Messaging.Message for the queue.

                System.Messaging.Message msg = GenerateDeleteMessage(ID);

                //Now we place it to the queue
                PlaceMessageOnQueue(msg);

                return true;
            }
            catch (Exception e)
            {
                return false;
            }

        }
        public System.Collections.ArrayList GetAll()
        {
            try
            {
                System.Collections.ArrayList a = new System.Collections.ArrayList();
                /*
                using (System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection())
               {
                   
                   //Open the connection
                   con.ConnectionString = "Data Source=localhost;Initial Catalog=ShireSchool;Integrated Security=True";
                   con.Open();
                   IDbCommand com = con.CreateCommand();
                   com.CommandType = CommandType.StoredProcedure;
                   com.CommandText = "GetDemographics";
                   IDataReader r = com.ExecuteReader();
                   while (r.Read())
                     
                   {
                       Student s = new Student();
                       s.ID=r["StudentIdentifier"].ToString();
                       s.FirstName = r["FirstName"].ToString();
                       s.LastName=r["LastName"].ToString();
                       s.PhoneNumber=r["PhoneNumber"].ToString();
                       a.Add((object)s);   
                   }
               }		
                
                
                    */
               return a;
            }
            catch (Exception e)
            {

                throw e;
            }


        }

        private System.Messaging.Message GenerateAddMessage(Student student)
        {

            try
            {
                System.Messaging.Message message = new Message();
                message.Priority = 0;
                message.Label = "Add";
                message.Body = student;

                return message;
            }
            catch (Exception e)
            {
                
                throw e;
            }

        }

        private Message GenerateUpdateMessage(Student student)
        {
            try
            {
                Message message = new Message();

                message.Priority = 0;
                message.Label = "Update";
                message.Body = student;

                return message;
            }
            catch (Exception e)
            {

                throw e;
            }

        }

        private System.Messaging.Message GenerateDeleteMessage(string ID)
        {
            try
            {
                System.Messaging.Message message = new Message();
                message.Priority = 0;
                message.Label = "Delete";
                message.Body = ID;

                return message;
            }
            catch (Exception e)
            {
                //Debug.WriteLine(e.ToString());
                throw e;
            }
        }

        private bool PlaceMessageOnQueue(Message message)
        {

            System.Messaging.MessageQueue q = new System.Messaging.MessageQueue(qPath);

            try
            {


                Type[] targetTypes = new Type[1];
                targetTypes[0] = typeof(Student);

                q.Formatter = new XmlMessageFormatter(targetTypes);

                //Send message to queue
                q.Send(message);
            }
            catch
            {

                return false;
            }
            finally
            {
                q.Close();
            }


            return true;

        }
    }
}
