﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Messaging;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
namespace WCFHandsOn
{
	
	class Program
	{
		static void Main(string[] args)
		{
			
			
			// Create a transaction queue using System.Messaging API
			// You could also choose to not do this and instead create the
			// queue using MSMQ MMC -make sure you create a transactional queue
			if (!MessageQueue.Exists(ConfigurationManager.AppSettings["queueName"]))
				MessageQueue.Create(ConfigurationManager.AppSettings["queueName"], true);

			//Connect to the queue
			MessageQueue Queue = new MessageQueue(ConfigurationManager.AppSettings["queueName"]);

			Queue.ReceiveCompleted += new ReceiveCompletedEventHandler(ProcessMessage);
			Queue.BeginReceive();
			Console.WriteLine("Message Processing Service is running");
			Console.ReadLine();
		}



        public static void ProcessMessage(Object source,
            ReceiveCompletedEventArgs asyncResult)
        {
            try
            {
                // Connect to the queue.
                MessageQueue Queue = (MessageQueue)source;

                // End the asynchronous receive operation.
                System.Messaging.Message msg = Queue.EndReceive(asyncResult.AsyncResult);

                msg.Formatter = new System.Messaging.XmlMessageFormatter(new Type[] { typeof(Student) });
                Student request = new Student();
                 request = (Student)msg.Body;
                switch (msg.Label)
                {
                    case "Add":
                        AddStudent(request);
                        break;
                    case "Update":
                        UpdateStudent(request);
                        break;
                    case "Delete":
                        DeleteStudent(request.ID);
                        break;
                    default:
                        Console.WriteLine("The label of the message is of an unknown type or not set correctly.");
                        break;

                }

                Queue.BeginReceive();
            }
            catch (System.Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
		
      
		private static void UpdateStudent(Student s)
		{
			
			using (System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection())
			{
				//This  code is commented out as these exercises are free of
                //dependencies on a database being installed.

                //Database updates would typically be done here.
                
                //Open the connection
                /*
                con.ConnectionString = ConfigurationManager.AppSettings["configurationString"];
                con.Open();
				IDbCommand com = con.CreateCommand();
				com.CommandType = CommandType.StoredProcedure;
				com.CommandText = "UpdateDemographic";
				  
				com.Parameters.Add(new SqlParameter("@studentIdentifier", SqlDbType.VarChar, 40).Value = s.ID);
				com.Parameters.Add(new SqlParameter("@FirstName", SqlDbType.VarChar, 15).Value = s.FirstName);
				com.Parameters.Add(new SqlParameter("@LastName", SqlDbType.VarChar, 40).Value = s.LastName);
				com.Parameters.Add(new SqlParameter("@phoneNumber", SqlDbType.VarChar, 15).Value = s.PhoneNumber);
				com.ExecuteScalar();
                */
                Console.WriteLine("Just updated student {0} {1} with a phone number of {2}", s.FirstName, s.LastName, s.PhoneNumber);
			}		
		}

		private static void AddStudent(Student s)
		{
			
			using (System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection())
			{
                Console.WriteLine("Just added student {0} {1} with a phone number of {2}", s.FirstName, s.LastName, s.PhoneNumber);			
                //Open the connection
				//con.ConnectionString = "Data Source=localhost;Initial Catalog=ShireSchool;Integrated Security=True";
                con.ConnectionString = ConfigurationManager.AppSettings["configurationString"];
                con.Open();
				IDbCommand com = con.CreateCommand();
				com.CommandType = CommandType.StoredProcedure;
				com.CommandText = "AddDemographics";
							
				com.Parameters.Add(new SqlParameter("@studentIdentifier", SqlDbType.VarChar,40).Value=s.ID);
				com.Parameters.Add(new SqlParameter("@FirstName", SqlDbType.VarChar,15).Value = s.FirstName);
				com.Parameters.Add(new SqlParameter("@LastName", SqlDbType.VarChar,40).Value = s.LastName);
				com.Parameters.Add(new SqlParameter("@phoneNumber", SqlDbType.VarChar,15).Value=s.PhoneNumber);
				com.ExecuteScalar();
                
                Console.WriteLine("Just added student {0} {1} with a phone number of {2}", s.FirstName, s.LastName, s.PhoneNumber);			
			}
			
		}

		private static void DeleteStudent(string studentID)
		{
			using (System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection())
			{
				//Open the connection
				con.ConnectionString = "Data Source=localhost;Initial Catalog=ShireSchool;Integrated Security=True";
				con.Open();
				IDbCommand com = con.CreateCommand();
				com.CommandType = CommandType.StoredProcedure;
				com.CommandText = "DeleteDemographic";

				com.Parameters.Add(new SqlParameter("@studentIdentifier", SqlDbType.VarChar, 40).Value = studentID);
				com.ExecuteScalar();

                Console.WriteLine("Just deleted student with ID {0}", studentID);
			}		
		}

	}
}
