﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Transactions;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace WCFHandsOn
{
	class Program
	{
		static void Main(string[] args)
		{
            AddStudent("Marc", "Mercuri", "123456789");
            
			Console.WriteLine();
			Console.WriteLine("Press <ENTER> to terminate client.");
			Console.ReadLine();
		}

        private static void AddStudent(string firstName, string lastName, string phoneNumber)
        {
            using (StudentManagementProxy p = new StudentManagementProxy("StudentManagementEndpoint"))
            {

                using (TransactionScope tx = new TransactionScope(TransactionScopeOption.Required))
                {
                    // Submit a job to add two numbers
                    StudentManagementRequest request = new StudentManagementRequest();

                    MsmqMessage<StudentManagementRequest> msg = new MsmqMessage<StudentManagementRequest>(request);

                    request.firstName = firstName;
                    request.lastName = lastName;
                    request.phoneNumber = phoneNumber;
                    request.studentID = System.Guid.NewGuid().ToString();
                    msg.Label = "Add";
                    msg.Body = request;
                    p.ProcessMessage(msg);

                    //Commit the transaction
                    tx.Complete();

                }


            }

        
        
        }
    }
}
