
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace WCFHandsOn
{

    [System.ServiceModel.ServiceContractAttribute(Namespace = "http://Microsoft.ServiceModel.Samples")]
    public interface IStudentManagement
    {

        [System.ServiceModel.OperationContractAttribute(IsOneWay = true, Action = "*")]
        void ProcessMessage(MsmqMessage<StudentManagementRequest> msg);
    }

    public interface IStudentManagementChannel : IStudentManagement, System.ServiceModel.IClientChannel
    {
    }

    public partial class StudentManagementProxy : System.ServiceModel.ClientBase<IStudentManagement>, IStudentManagement
    {

        public StudentManagementProxy()
        {
        }

        public StudentManagementProxy(string configurationName)
            :
                base(configurationName)
        {
        }

        public StudentManagementProxy(System.ServiceModel.Binding binding)
            :
                base(binding.Name.ToString())
        {
        }

        public StudentManagementProxy(System.ServiceModel.EndpointAddress address, System.ServiceModel.Binding binding)
            :
                base(address.Uri.ToString(), binding.Name.ToString())
        {
        }

        public void ProcessMessage(MsmqMessage<StudentManagementRequest> msg)
        {
            base.InnerProxy.ProcessMessage(msg);
        }
    }
}