﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Messaging;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
namespace WCFHandsOn
{
	
	class Program
	{
		static void Main(string[] args)
		{
			
			
			// Create a transaction queue using System.Messaging API
			// You could also choose to not do this and instead create the
			// queue using MSMQ MMC -make sure you create a transactional queue
			if (!MessageQueue.Exists(ConfigurationManager.AppSettings["queueName"]))
				MessageQueue.Create(ConfigurationManager.AppSettings["queueName"], true);

			//Connect to the queue
			MessageQueue Queue = new MessageQueue(ConfigurationManager.AppSettings["queueName"]);

			Queue.ReceiveCompleted += new ReceiveCompletedEventHandler(ProcessMessage);
			Queue.BeginReceive();
			Console.WriteLine("Message Processing Service is running");
			Console.ReadLine();
		}



        public static void ProcessMessage(Object source,
            ReceiveCompletedEventArgs asyncResult)
        {
            try
            {
                // Connect to the queue.
                MessageQueue Queue = (MessageQueue)source;

                // End the asynchronous receive operation.
                System.Messaging.Message msg = Queue.EndReceive(asyncResult.AsyncResult);

                msg.Formatter = new System.Messaging.XmlMessageFormatter(new Type[] { typeof(StudentManagementRequest) });

                StudentManagementRequest request = (StudentManagementRequest)msg.Body;
                switch (msg.Label)
                {
                    case "Add":
                        AddStudent(request);
                        break;
                    case "Update":
                        UpdateStudent(request);
                        break;
                    case "Delete":
                        DeleteStudent(request.studentID);
                        break;
                    default:
                        Console.WriteLine("The label of the message is of an unknown type or not set correctly.");
                        break;

                }

                Queue.BeginReceive();
            }
            catch (System.Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
		
      
		private static void UpdateStudent(StudentManagementRequest s)
		{
	       Console.WriteLine("Just updated student {0} {1} with a phone number of {2}", s.firstName, s.lastName, s.phoneNumber);
	
		}

		private static void AddStudent(StudentManagementRequest s)
		{
			
         Console.WriteLine("Just added student {0} {1} with a phone number of {2}", s.firstName, s.lastName, s.phoneNumber);			
			
		}

		private static void DeleteStudent(string studentID)
		{

                Console.WriteLine("Just deleted student with ID {0}", studentID);
		}

	}
}
