using System;
using System.Collections.Generic;
using System.Configuration;
using System.ServiceModel;
using System.Text;

namespace CustomTransport
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Type serviceType = typeof(GreetingServiceType);

            string tcpBaseAddress =
                ConfigurationManager.AppSettings["TCPBaseAddress"];
            Uri tcpBaseAddressURI = new Uri(tcpBaseAddress);
            Uri[] baseAdresses = new Uri[] { 
                tcpBaseAddressURI};

            using(ServiceHost host = new ServiceHost(
                serviceType,
                baseAdresses))
            {
                host.AddServiceEndpoint(
                    typeof(IGreeting), 
                    new NetTcpBinding(), 
                    ConfigurationManager.AppSettings[
                    "GreetingEndpointAddress"]);
                host.Open();

                Console.WriteLine(
                    "The derivatives calculator service is available."
                );
                Console.ReadKey();

                host.Close();
            }
        }
    }
}
