
using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace ClientAuditBehavior
{
	[AttributeUsage(AttributeTargets.Class)]
	public class AuditAttribute: Attribute, IChannelBehavior
	{
		public void ApplyBehavior(
            ChannelDescription description, 
            ProxyBehavior behavior, 
            BindingParameterCollection parameters)
		{
			ChannelFactory<IAudit> fact = 
                new ChannelFactory<IAudit>("ClientAudit");
			IAudit prt = fact.CreateChannel();

            ClientAuditMessageInspector insp = 
                new ClientAuditMessageInspector(prt);

			behavior.MessageInspectors.Add(insp);
		
		
		}
	
	
	}
}
 

