using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Configuration;
using System.Collections.ObjectModel;
namespace ServiceAuditBehavior
{
    [AttributeUsage(AttributeTargets.Class)]
    public class AuditAttribute : Attribute, IServiceBehavior
    {
        public void ApplyBehavior(ServiceDescription description, ServiceHostBase shBase, Collection<DispatchBehavior> behaviors, Collection<BindingParameterCollection> parameters)
        {
            foreach (DispatchBehavior behavior in behaviors)
            {
                ChannelFactory<IAudit> fact = new ChannelFactory<IAudit>("ServiceAudit");
                IAudit prt = fact.CreateChannel();
                ServiceAuditMessageInspector insp = new ServiceAuditMessageInspector(prt);
                behavior.MessageInspectors.Add(insp);
                }

        }
    }
}
