using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.ServiceModel;
using System.Text;

namespace Client
{
	[ServiceContract]
	public interface IPictureServer
	{
		[OperationContract]
		Stream GetPicture(string pictureName);


	}

	class Program
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Press any key when the service is available.");
			Console.ReadKey();

			byte[] buffer = new byte[1024];

			IPictureServer pictureServer = new ChannelFactory<IPictureServer>("PictureServer").CreateChannel();
			Stream pictureStream = pictureServer.GetPicture("Pony.jpg");
			while (pictureStream.Read(buffer, 0, 1024) > 0)
			{
				Console.WriteLine("Reading");
			}
            Console.WriteLine("Done");
			

			((IChannel)pictureServer).Close();

			Console.ReadKey();


		}
	}
}
