using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Text;

namespace PublicationSubscription
{
	public class PublisherProxy: ClientBase<IPublisher>, IPublisher
	{
		private PublisherProxy()
		{
		}

		public PublisherProxy(string configurationName): base(configurationName)
		{
		}

		#region IPublisher Members

		KnownDataPoint[] IPublisher.GetKnownDataPoints()
		{
			return this.InnerProxy.GetKnownDataPoints();
		}

		void IPublisher.Subscribe(KnownDataPoint[] dataPoints, out bool subscriptionAccepted)
		{
			this.InnerProxy.Subscribe(dataPoints, out subscriptionAccepted);
		}

		#endregion
}
}
