using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.ServiceModel;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Client
{
	delegate void RetrievePictureDelegate(object state);

	[ServiceContract]
	public interface IPictureServer
	{
		[OperationContract]
		Stream GetPicture(string pictureName);
	}


	public partial class Main : Form
	{
		public Main()
		{
			InitializeComponent();
		}

		private void Main_Load(object sender, EventArgs e)
		{
			
		}

		private void RetrievePicture(object state)
		{
			if (this.InvokeRequired)
			{
				IPictureServer pictureServer = new ChannelFactory<IPictureServer>("PictureServer").CreateChannel();
				Stream pictureStream = pictureServer.GetPicture(ConfigurationManager.AppSettings["PictureName"]);
				((IChannel)pictureServer).Close();
				
				this.Invoke(new RetrievePictureDelegate(this.RetrievePicture),new object[]{pictureStream});
			}
			else
			{
				Bitmap bitMap = new Bitmap((Stream)state);
				this.Picture.Image = bitMap;
			}
		}

		private void StartButton_Click(object sender, EventArgs e)
		{
			ThreadPool.QueueUserWorkItem(new WaitCallback(this.RetrievePicture));
			
			
		}
	}
}