using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ServiceModel;
using System.Threading;

namespace WindowsCommunicationFoundationHandsOn.School
{
	[ServiceContract]
	public interface IPeerResolver
	{
		[OperationContract]
		object Register(string meshIdentifier, PeerNodeAddress nodeAddress, TimeSpan timeout);
		[OperationContract]
		PeerNodeAddress[] Resolve(string meshIdentifier, int maximumAddresses, TimeSpan timeout);
		[OperationContract]
		void Unregister(object registrationId, TimeSpan timeout);
		[OperationContract]
		void Update(object registrationId, PeerNodeAddress updatedNodeAddress, TimeSpan timeout);
	}

}
