using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Text;

namespace Fabrikam
{
    public class ReliableHttpBinding: CustomBinding, IBindingCapabilities
    {
        public ReliableHttpBinding()
        {
            this.Elements.Add(new ReliableSessionBindingElement(false));
            this.Elements.Add(new HttpTransportBindingElement());
        }

        #region IBindingCapabilities Members

        bool IBindingCapabilities.AssuresOrderedDelivery
        {
            get 
            { 
                return false;
            }
        }

        bool IBindingCapabilities.IsTransactionAware
        {
            get
            {
                return true;
            }
        }

        bool IBindingCapabilities.QueuedDelivery
        {
            get
            {
                return false;
            }
        }

        #endregion
    }
}
