using System;
using System.Collections.Generic;
using System.Configuration;
using System.ServiceModel;
using System.Text;

using Microsoft.ServiceModel.Samples;

namespace CustomTransport
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Console.WriteLine("Press any key when the service is ready.");
            Console.ReadKey();

            MailTransportBindingElement transportBindingElement = new MailTransportBindingElement();
            transportBindingElement.UserName = "WCFHandsOnReader@WCFHandsOn.COM";
            transportBindingElement.Password = "pass@word1";
            transportBindingElement.FromAddress = "WCFHandsOnReader@WCFHandsOn.COM";

            MailMessageEncodingBindingElement encodingBindingElement = new MailMessageEncodingBindingElement();

            CustomBinding binding = new CustomBinding(new BindingElement[] { encodingBindingElement, transportBindingElement });
            
            IGreeting proxy = new ChannelFactory<IGreeting>(
                binding, 
                new EndpointAddress(
"smtp.pop3://localhost:110/WCFHandsOnReader@WCFHandsOn.COM"))
                        .CreateChannel();
            proxy.Greeting(
                "Hello, world.");
            ((IChannel)proxy).Close();
            
            
            Console.WriteLine("Press any key to exit.");
            Console.ReadKey();

        }
    }
}
