using System;
using System.Collections.Generic;
using System.Configuration;
using System.ServiceModel;
using System.Text;

using Microsoft.ServiceModel.Samples;

namespace CustomTransport
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Type serviceType = typeof(GreetingServiceType);

            string mailBaseAddress = "smtp.pop3://localhost:110/";
            Uri mailBaseAdressURI = new Uri(mailBaseAddress);
            Uri[] baseAdresses = new Uri[] { 
                mailBaseAdressURI};

            MailTransportBindingElement transportBindingElement = new MailTransportBindingElement();
            transportBindingElement.UserName = "WCFHandsOnReader@WCFHandsOn.COM";
            transportBindingElement.Password = "pass@word1";
            
            MailMessageEncodingBindingElement encodingBindingElement = new MailMessageEncodingBindingElement();

            CustomBinding binding = new CustomBinding(new BindingElement[] { encodingBindingElement, transportBindingElement });

            using(ServiceHost host = new ServiceHost(
                serviceType,
                baseAdresses))
            {
                host.AddServiceEndpoint(
                    typeof(IGreeting), 
                    binding, 
                    "WCFHandsOnReader@WCFHandsOn.COM");
                host.Open();

                Console.WriteLine(
                    "The derivatives calculator service is available."
                );
                Console.ReadKey();

                host.Close();
            }
        }
    }
}
