using System;
using System.Collections.Generic;
using System.Text;

namespace DominoClient
{
    class Program
    {
        static void Main(string[] args)
        {
        
        using (UpdateProxy proxy = new UpdateProxy("DominoOrders"))
        {
            string customerID = "1";
            string orderDate = "10/25/2006";
            string weight = "50";
            string freight = "100";
            string shipAddress = "1 main street";
            string shipCity = "Redmond";
            string shipCountry = "USA";
            string amount = "500.00";
            
            //PLACE THE ORDER            
            int orderID = proxy.NEWORDER(customerID,orderDate,amount, freight, weight, shipAddress, shipCity, shipCountry);
            System.Console.WriteLine("Your order was placed. Your order ID for future reference is " + orderID.ToString());

            
            //CHECK THE STATUS OF THE ORDER
            System.Console.WriteLine("----------------------------------------------------------------------------");
            string status = proxy.CHECKSTATUS(orderID);
            System.Console.WriteLine();
            System.Console.WriteLine("Your order status is: " + status);
            
            //CANCEL THE ORDER
            System.Console.WriteLine("----------------------------------------------------------------------------");
            System.Console.WriteLine("Approving order#" + orderID.ToString());
            proxy.CHANGESTATUS(orderID, "Approved");

            // CHECK THE ORDER STATUS, TO SEE IF IT'S APPROVED
            System.Console.WriteLine("----------------------------------------------------------------------------");
            status = proxy.CHECKSTATUS(orderID);
            System.Console.WriteLine();
            System.Console.WriteLine("Your order status is: " + status);
            System.Console.ReadLine();
        
        }
        
        }
    }
}
