using System;
using System.Collections.Generic;
using System.Messaging;
using System.ServiceModel;
using System.Text;

namespace Fabrikam
{
    public class Program
    {
        private const string queueName = @".\private$\traderecording";

        public static void Main(string[] args)
        {
            if (!(MessageQueue.Exists(queueName)))
            {
                MessageQueue.Create(queueName, true);
            }

            TradeRecorder tradeRecorder = new TradeRecorder();
            using (ServiceHost host = new ServiceHost(tradeRecorder))
            {
                host.Open();
                tradeRecorder.InitializeCounters(host.Description.Endpoints);
                Console.WriteLine("The trade recording service is available.");
                Console.ReadKey();
            }

        }
    }


}

