using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Text;

namespace WindowsCommunicationFoundationHandsOn.School
{
	public class ResolverClient : PeerResolver
	{
		private IPeerResolver resolver = null;

		private ResolverClient()
		{
		}

		public ResolverClient(IPeerResolver resolver)
		{
			this.resolver = resolver;
		}

		
		public override object Register(string meshId, PeerNodeAddress nodeAddress, TimeSpan timeout)
		{
			object registrationId = this.resolver.Register(meshId, nodeAddress, timeout);
			return registrationId;
		}

		public override System.Collections.ObjectModel.ReadOnlyCollection<PeerNodeAddress> Resolve(string meshId, int maxAddresses, TimeSpan timeout)
		{
			PeerNodeAddress[] addressArray = this.resolver.Resolve(meshId, maxAddresses, timeout);
			System.Collections.ObjectModel.ReadOnlyCollection<PeerNodeAddress> addresses = new System.Collections.ObjectModel.ReadOnlyCollection<PeerNodeAddress>(addressArray);
			return addresses;
		}

		public override void Unregister(object registrationId, TimeSpan timeout)
		{
			this.resolver.Unregister(registrationId, timeout);
		}

		public override void Update(object registrationId, PeerNodeAddress updatedNodeAddress, TimeSpan timeout)
		{
			this.resolver.Update(registrationId, updatedNodeAddress, timeout);
		}
	}
}

