using System;
using System.Collections.Generic;
using System.IO;
using System.ServiceModel;
using System.Text;
using System.Xml;

namespace RepresentationalStateTransfer
{
	public class PlainXMLRepresentationalStateTransferServiceHost
	{
		private const string baseAddress = @"http://localhost:8888/";
		private const string endpointAddress = @"Service";
		private const string feedback = 
            @"The service is available.  Press any key to terminate it.";

		static void Main(string[] arguments)
		{
			ReallySimpleSyndicationServer serviceType 
                = new ReallySimpleSyndicationServer(arguments[0]);
			ServiceHost service = new ServiceHost(
                serviceType, new Uri[] {new Uri(@"http://localhost:8888/") });
		
			service.Description.Behaviors.Remove(
                typeof(ServiceMetadataBehavior));

			service.Open();

			Console.WriteLine(
                @"The service is available.  Press any key to terminate it.");
			Console.ReadLine();


		}

		
		
	}
}
