using System.IO;
using System.ServiceModel;
using System.Text;
using System.Xml;

namespace RepresentationalStateTransfer
{
	public class ReallySimpleSyndicationServer : IReallySimpleSyndication
	{
		private string feedFilePath = null;

		public ReallySimpleSyndicationServer(string feedFilePath)
		{
			this.feedFilePath = feedFilePath;
		}

		private ReallySimpleSyndicationServer()
		{
		}

		Message IReallySimpleSyndication.Get(Message input)
		{
			Message message = null;
			if (File.Exists(this.feedFilePath))
			{
				XmlDocument document = new XmlDocument();
				document.Load(this.feedFilePath);

				ReallySimpleRatedSyndication.AddSignedContentRating(document);

				message = Message.CreateMessage("*", new XmlNodeReader(document.DocumentElement));
			
			}
			else
			{
				message = Message.CreateMessage(Constants.DefaultAction);
			}

			return message;
		}
	}
}

