using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.ServiceModel;
using System.Resources;
using System.Text;
using System.Xml;
using System.Windows.Forms;

using RepresentationalStateTransfer.Properties;

namespace RepresentationalStateTransfer
{
	public partial class MainForm : Form
	{
		private const string baseAddress = @"http://localhost:8888/";
		private const string endpointAddress = @"Service";

		public MainForm()
		{
			InitializeComponent();
		}

		private void MainForm_Load(object sender, EventArgs e)
		{
            IReallySimpleSyndication client = 
                new ChannelFactory<IReallySimpleSyndication>(
                    "ReallySimpleSyndicationService").CreateChannel();
            System.ServiceModel.Message message = 
                System.ServiceModel.Message.CreateMessage(
                    Constants.DefaultAction);
            System.ServiceModel.Message output = client.Get(message);

            XmlDocument document = new XmlDocument();
            XmlDictionaryReader reader = output.GetReaderAtBodyContents();
            document.LoadXml(reader.ReadOuterXml());

            ContentRating rating;
            string link = null;
            bool validRating = 
                ReallySimpleRatedSyndication.ValidateSignedContentRating(
                    document, 
                    out rating, 
                    out link);

            if ((validRating) && (rating == ContentRating.AllAges))
            {
                try
                {
                    this.browser.Url = new Uri(link);
                }
                catch (Exception)
                {
                    this.browser.DocumentText = string.Empty;
                }
            }
            else
            {
                this.browser.DocumentText = Resources.Prohibited;
            }

		}
	}
}