using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace SecurityTokenService
{
	public enum SECURITYIDENTIFIER_NAME_USE
	{
		SidTypeUser = 1,
		SidTypeGroup,
		SidTypeDomain,
		SidTypeAlias,
		SidTypeWellKnownGroup,
		SidTypeDeletedAccount,
		SidTypeInvalid,
		SidTypeUnknown,
		SidTypeComputer
	}

	public class SecurityIdentifierInterpreter
	{
		[DllImport("Advapi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		private static extern bool LookupAccountSid(string systemName, IntPtr securityIdentifier, StringBuilder nameBuffer, ref uint nameBufferSize, StringBuilder referencedDomainNameBuffer, ref uint referencedDomainNameBufferSize, out SECURITYIDENTIFIER_NAME_USE peuse);
		[DllImport("advapi32.dll", SetLastError = true)]
		private static extern bool ConvertStringSidToSid(string lbBuffer, out IntPtr ptrSid);

		public static string ConvertSecurityIdentifierToName(string securityIdentifierString, out int error)
		{
			error = -1;
			StringBuilder nameBuffer = new StringBuilder(1000);
			uint nameBufferSize = (uint)nameBuffer.Capacity;
			StringBuilder referencedDomainNameBuffer = new StringBuilder(1000);
			uint referencedDomainNameBufferSize = (uint)referencedDomainNameBuffer.Capacity;
			SECURITYIDENTIFIER_NAME_USE securityIdentifierUse;
			IntPtr securityIdentifier;
			bool result = SecurityIdentifierInterpreter.ConvertStringSidToSid(securityIdentifierString, out securityIdentifier);
			if (!(result))
			{
				error = Marshal.GetLastWin32Error();
				return null;
			}
			result = SecurityIdentifierInterpreter.LookupAccountSid(null, securityIdentifier, nameBuffer, ref nameBufferSize, referencedDomainNameBuffer, ref referencedDomainNameBufferSize, out securityIdentifierUse);
			if (!(result))
			{
				error = Marshal.GetLastWin32Error();
				return null;
			}

			return nameBuffer.ToString();
		}
	}
}
